"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

function _utils() {
  const data = require("@umijs/utils");

  _utils = function _utils() {
    return data;
  };

  return data;
}

var _utils2 = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _default(api) {
  api.describe({
    key: 'runtimeImport',
    config: {
      default: {},

      schema(joi) {
        return joi.object({
          base: joi.string(),
          js: joi.object().unknown(true).pattern(joi.any(), joi.object({
            moduleName: joi.string().required(),
            url: joi.string().required(),
            base: joi.string()
          })),
          css: joi.object().unknown(true).pattern(joi.string(), [joi.string(), joi.object({
            url: joi.string().required(),
            base: joi.string()
          })])
        });
      },

      onChange: api.ConfigChangeType.regenerateTmpFiles
    },
    enableBy: api.EnableBy.config
  });
  let scripts = [];
  let links = [];
  api.chainWebpack((memo, args) => {
    var _api$config, _args$webpack;

    const assets = (0, _utils2.formatOpt)(((_api$config = api.config) === null || _api$config === void 0 ? void 0 : _api$config.runtimeImport) || {});

    if (!!args.mfsu) {
      return memo;
    }

    const RuntimeImportPlugin = ((_args$webpack = args.webpack) === null || _args$webpack === void 0 ? void 0 : _args$webpack.isWebpack5) ? require('./webpack5') : require('./webpack4');
    memo.plugin('RuntimeImportPlugin').use(RuntimeImportPlugin, [{
      assets,
      getEntryAssets: (type, addon) => {
        const set = Object.values(addon);

        if (type === 'js') {
          scripts = _utils().lodash.uniqBy(scripts.concat((0, _utils2.getScripts)(set)), script => typeof script === 'string' ? script : script.src);
        }

        if (type === 'css') {
          links = _utils().lodash.uniq(links.concat((0, _utils2.getStyles)(set)[0]));
        }
      }
    }]);
    return memo;
  });
  api.modifyConfig(memo => {
    if (!!memo.mfsu) {
      return memo;
    }

    const externals = memo.externals || {};
    let assets = (memo === null || memo === void 0 ? void 0 : memo.runtimeImport) || {};
    Object.entries(assets.js || {}).forEach(([key, value]) => {
      externals[key] = `var ${value.moduleName}`;
    });
    return _objectSpread(_objectSpread({}, memo), {}, {
      externals
    });
  });
  api.addHTMLScripts(() => scripts);
  api.addHTMLLinks(() => links);
}