"use strict";

function _webpack() {
  const data = require("webpack");

  _webpack = function _webpack() {
    return data;
  };

  return data;
}

function _Chunk() {
  const data = _interopRequireDefault(require("webpack/lib/Chunk"));

  _Chunk = function _Chunk() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

const PluginName = 'RuntimeImportPlugin';
module.exports = class RuntimeImportPlugin {
  constructor({
    assets,
    getEntryAssets
  }) {
    this.assets = void 0;
    this.installedCss = {};
    this.cdnCss = {};
    this.cdnJs = {};

    this.getEntryAssets = () => null;

    this.addEntryAssets = (type, chunk) => {
      const global = {};
      Object.entries(this.assets[type] || {}).forEach(([k, v]) => {
        if (!global[k] && this.findDependencies(k, chunk.entryModule)) {
          global[k] = v.url;
        }
      });
      this.getEntryAssets(type, global);
    };

    this.findDependencies = (dep, module, res = {}) => {
      if (module === null || module === void 0 ? void 0 : module.dependencies) {
        var _iterator = _createForOfIteratorHelper(module.dependencies),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            let d = _step.value;
            if (d.request === dep) return true;

            if (d.module && d.userRequest && !res[d.userRequest]) {
              res[d.userRequest] = true;

              if (this.findDependencies(dep, d.module, res)) {
                return true;
              }
            }
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      }

      return false;
    };

    this.getDependencies = modules => {
      let dependencies = [];
      modules.forEach(module => {
        if (typeof module.source === 'function') {
          var _module$blocks;

          (_module$blocks = module.blocks) === null || _module$blocks === void 0 ? void 0 : _module$blocks.forEach(block => {
            block.dependencies.forEach(d => {
              var _d$block;

              let chunkGroup = (_d$block = d.block) === null || _d$block === void 0 ? void 0 : _d$block.chunkGroup;
              if (!chunkGroup) return;
              dependencies.push(d);
            });
          });
        }
      });
      return dependencies;
    };

    this.addJsTemplate = (compiler, compilation) => {
      var _compilation$mainTemp;

      compilation.mainTemplate.hooks.localVars.tap(PluginName, source => source.replace(`function jsonpScriptSrc(chunkId) {`, searchValue => _webpack().Template.asString([`var cdnJs = typeof window !== "undefined" && window.__RUNTIME_IMPORT_JS__ || ${JSON.stringify(this.cdnJs, null, '\t')};`, searchValue, _webpack().Template.indent([`if(cdnJs[chunkId]) {`, _webpack().Template.indent([`return cdnJs[chunkId].url;`]), `}`])])));
      (_compilation$mainTemp = compilation.mainTemplate.hooks.requireEnsure) === null || _compilation$mainTemp === void 0 ? void 0 : _compilation$mainTemp.tap(PluginName, source => {
        var _compiler$options$out;

        const outputName = `window["${((_compiler$options$out = compiler.options.output) === null || _compiler$options$out === void 0 ? void 0 : _compiler$options$out.jsonpFunction) || 'webpackJsonp'}"]`;
        return source.replace(`var chunk = installedChunks[chunkId];`, searchValue => _webpack().Template.asString([searchValue, _webpack().Template.indent([_webpack().Template.indent([`if(cdnJs[chunkId]) {`, _webpack().Template.indent([`${outputName}.push([[chunkId], window[cdnJs[chunkId].moduleName]]);`]), '}'])])])).replace(`var script = document.createElement('script')`, searchValue => _webpack().Template.asString([`if(cdnJs[chunkId] && cdnJs[chunkId].moduleName && window[cdnJs[chunkId].moduleName]) {`, _webpack().Template.indent([`${outputName}.push([[chunkId], window[cdnJs[chunkId].moduleName]]);`]), `} else {`, _webpack().Template.indent([searchValue])])).replace(`document.head.appendChild(script);`, searchValue => _webpack().Template.asString([_webpack().Template.indent([_webpack().Template.indent([searchValue])]), '}']));
      });
    };

    this.addJsDependencies = compilation => {
      compilation.hooks.afterOptimizeChunks.tap(PluginName, chunks => {
        var _iterator2 = _createForOfIteratorHelper(chunks),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            const chunk = _step2.value;

            if (chunk.hasRuntime()) {
              this.addEntryAssets('js', chunk);
            }

            let dependencies = this.getDependencies(chunk.getModules());

            var _iterator3 = _createForOfIteratorHelper(dependencies),
                _step3;

            try {
              for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                var _d$block2;

                let d = _step3.value;
                let chunkGroup = (_d$block2 = d.block) === null || _d$block2 === void 0 ? void 0 : _d$block2.chunkGroup;

                for (let key in this.assets.js) {
                  if (chunkGroup && !chunkGroup.chunks.find(ele => `${ele.id}` === key) && this.findDependencies(key, d.module)) {
                    var _chunkGroup$chunks;

                    let chunk = new (_Chunk().default)();
                    chunk.id = key;
                    chunk.chunkReason = 'cdn';
                    (_chunkGroup$chunks = chunkGroup.chunks) === null || _chunkGroup$chunks === void 0 ? void 0 : _chunkGroup$chunks.push(chunk);
                    this.cdnJs[key] = this.assets.js[key];
                  }
                }
              }
            } catch (err) {
              _iterator3.e(err);
            } finally {
              _iterator3.f();
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      });
    };

    this.addCssTemplate = compilation => {
      compilation.mainTemplate.hooks.localVars.tap(PluginName, source => {
        return _webpack().Template.asString([source, '', '// object to store loaded cdn CSS chunks', `var installedCdnCssChunks = {};`, `var cdnCss = typeof window !== "undefined" && window.__RUNTIME_IMPORT_CSS__ || ${JSON.stringify(this.cdnCss, null, '\t')};`]);
      });
      compilation.mainTemplate.hooks.requireEnsure.tap(PluginName, source => {
        return _webpack().Template.asString([source, `if(installedCdnCssChunks[chunkId]) promises.push(installedCdnCssChunks[chunkId]);`, `else if(installedCdnCssChunks[chunkId] !== 0 && cdnCss[chunkId]) {`, _webpack().Template.indent([`promises.push(installedCdnCssChunks[chunkId] = Promise.all(cdnCss[chunkId].map(function(href) {`, _webpack().Template.indent([`var fullhref = href;`, `return new Promise(function(resolve, reject) {`, _webpack().Template.indent(['var existingLinkTags = document.getElementsByTagName("link");', 'for(var i = 0; i < existingLinkTags.length; i++) {', _webpack().Template.indent(['var tag = existingLinkTags[i];', 'var dataHref = tag.getAttribute("data-href") || tag.getAttribute("href");', 'if(tag.rel === "stylesheet" && (dataHref === href || dataHref === fullhref)) return resolve();']), '}', 'var existingStyleTags = document.getElementsByTagName("style");', 'for(var i = 0; i < existingStyleTags.length; i++) {', _webpack().Template.indent(['var tag = existingStyleTags[i];', 'var dataHref = tag.getAttribute("data-href");', 'if(dataHref === href || dataHref === fullhref) return resolve();']), '}', 'var linkTag = document.createElement("link");', 'linkTag.rel = "stylesheet";', 'linkTag.type = "text/css";', 'linkTag.onload = resolve;', 'linkTag.onerror = function(event) {', _webpack().Template.indent(['var request = event && event.target && event.target.src || fullhref;', 'var err = new Error("Loading CSS chunk " + chunkId + " failed.\\n(" + request + ")");', 'err.code = "Cdn_CSS_CHUNK_LOAD_FAILED";', 'err.request = request;', `delete installedCdnCssChunks[chunkId]`, 'linkTag.parentNode.removeChild(linkTag)', 'reject(err);']), '};', 'linkTag.href = fullhref;', 'document.head.appendChild(linkTag);']), `});`]), `})).then(function() {`, _webpack().Template.indent([`installedCdnCssChunks[chunkId] = 0;`]), '}));']), '}']);
      });
    };

    this.addCssDependencies = compilation => {
      compilation.hooks.afterOptimizeDependencies.tap(PluginName, modules => {
        Object.entries(this.assets.css || {}).forEach(([key, val]) => {
          if (!this.installedCss[key]) {
            modules.filter(m => {
              var _m$issuer;

              return ((_m$issuer = m.issuer) === null || _m$issuer === void 0 ? void 0 : _m$issuer.rawRequest) === key;
            }).forEach(m => {
              var _m$buildInfo;

              //i don't know how to exclude it now, so, clear the content
              m.content = `/* cdn  ${val.url} */`;
              ((_m$buildInfo = m.buildInfo) === null || _m$buildInfo === void 0 ? void 0 : _m$buildInfo.assets) == null;
              this.installedCss[key] = true;
            });
          }
        });
      });
      compilation.hooks.afterOptimizeChunkIds.tap(PluginName, () => {
        if (this.assets.css) {
          var _iterator4 = _createForOfIteratorHelper(compilation.chunks),
              _step4;

          try {
            for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
              const chunk = _step4.value;

              (chunk => {
                if (chunk.hasRuntime()) {
                  this.addEntryAssets('css', chunk);
                } //find css map


                var _iterator5 = _createForOfIteratorHelper(chunk.getAllAsyncChunks()),
                    _step5;

                try {
                  for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                    let c = _step5.value;
                    Object.entries(this.assets.css).forEach(([key, val]) => {
                      var _this$cdnCss$c$id;

                      if (!((_this$cdnCss$c$id = this.cdnCss[c.id]) === null || _this$cdnCss$c$id === void 0 ? void 0 : _this$cdnCss$c$id.includes(val.url))) {
                        var _iterator6 = _createForOfIteratorHelper(c.modulesIterable),
                            _step6;

                        try {
                          for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                            let m = _step6.value;

                            if (m.type === 'css/mini-extract' && m.issuer.rawRequest === key) {
                              this.cdnCss[c.id] = (this.cdnCss[c.id] || []).concat([val.url]);
                            }
                          }
                        } catch (err) {
                          _iterator6.e(err);
                        } finally {
                          _iterator6.f();
                        }
                      }
                    });
                  }
                } catch (err) {
                  _iterator5.e(err);
                } finally {
                  _iterator5.f();
                }
              })(chunk);
            }
          } catch (err) {
            _iterator4.e(err);
          } finally {
            _iterator4.f();
          }
        }
      });
    };

    this.assets = assets;
    this.getEntryAssets = getEntryAssets;
  }

  apply(compiler) {
    compiler.hooks.compilation.tap(PluginName, compilation => {
      this.addJsTemplate(compiler, compilation);
      this.addJsDependencies(compilation);
      this.addCssTemplate(compilation);
      this.addCssDependencies(compilation);
    });
  }

};