"use strict";

function _webpack() {
  const data = require("webpack");

  _webpack = function _webpack() {
    return data;
  };

  return data;
}

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

const pluginName = 'RuntimeImportPlugin';
module.exports = class RuntimeImportPlugin {
  constructor({
    assets,
    getEntryAssets
  }) {
    this.assets = void 0;
    this.cdnCss = {};
    this.cdnJs = {};

    this.getEntryAssets = () => null;

    this.findDependencies = (chunk, compilation) => {
      let modules = Array.from(compilation.chunkGraph.getChunkModulesIterable(chunk));
      let allKeys = [...Object.keys(this.cdnCss), ...Object.keys(this.cdnJs)];
      let dependencies = [];
      modules.forEach(module => {
        for (var _i = 0, _arr = ['rawRequest', 'userRequest']; _i < _arr.length; _i++) {
          let request = _arr[_i];

          if (allKeys.includes(module[request])) {
            dependencies.push({
              request: module[request],
              requestKey: request,
              module: module
            });
            break;
          }
        }
      });
      return dependencies;
    };

    this.cdnJs = assets.js;
    this.cdnCss = assets.css;
    this.getEntryAssets = getEntryAssets;
  }

  apply(compiler) {
    let externals = {};

    for (let key in this.cdnJs) {
      const _this$cdnJs$key = this.cdnJs[key],
            url = _this$cdnJs$key.url,
            moduleName = _this$cdnJs$key.moduleName;
      externals[key] = [url, moduleName];
    }

    new (_webpack().ExternalsPlugin)('script', externals).apply(compiler);
    compiler.hooks.thisCompilation.tap(pluginName, compilation => {
      let cssChunkMap = {};
      compilation.hooks.optimizeChunks.tap({
        name: pluginName,
        stage: 'STAGE_ADVANCED'
      }, chunks => {
        var _iterator = _createForOfIteratorHelper(chunks),
            _step;

        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            const chunk = _step.value;
            let dependencies = this.findDependencies(chunk, compilation);
            let isEntry = chunk.canBeInitial();
            dependencies.forEach(dependency => {
              let key = dependency.request;

              if (isEntry) {
                if (this.cdnJs[key]) {
                  let cdn = this.cdnJs[key];
                  dependency.module.externalType = 'var';
                  dependency.module.request = cdn.moduleName;
                }

                if (key.endsWith('.css')) {
                  this.getEntryAssets('css', [this.cdnCss[key].url]);
                } else {
                  this.getEntryAssets('js', [this.cdnJs[key].url]);
                }
              }

              if (this.cdnCss[key]) {
                if (!cssChunkMap[chunk.debugId]) {
                  cssChunkMap[chunk.debugId] = {
                    isEntry,
                    modules: []
                  };
                }

                cssChunkMap[chunk.debugId].modules.push(dependency);
              }
            });
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }

        var _iterator2 = _createForOfIteratorHelper(chunks),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            let chunk = _step2.value;
            let modules = Array.from(compilation.chunkGraph.getChunkModulesIterable(chunk));
            Object.values(cssChunkMap).reduce((a, b) => {
              return [...a, ...b.modules];
            }, []).forEach(chunk => {
              modules.forEach(module => {
                var _compilation$moduleGr;

                if (module.type === 'css/mini-extract' && ((_compilation$moduleGr = compilation.moduleGraph.getIssuer(module)) === null || _compilation$moduleGr === void 0 ? void 0 : _compilation$moduleGr.debugId) == chunk.module.debugId) {
                  compilation.chunkGraph.disconnectChunkAndModule(chunk, module);
                }
              });
            });
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      });
      compilation.mainTemplate.hooks.requireEnsure.tap(pluginName, source => {
        let chunks = Array.from(compilation.chunks);
        let cssObj = {};

        if (Object.keys(cssChunkMap).length) {
          for (let key in cssChunkMap) {
            let v = cssChunkMap[key];
            if (v.isEntry) continue;
            let match = chunks.find(ele => ele.debugId == key);

            if (match) {
              cssObj[match.id] = [];
              v.modules.forEach(ele => {
                cssObj[match.id].push(this.cdnCss[ele.request].url);
              });
            }
          }
        }

        return _webpack().Template.asString([source, _webpack().Template.indent([_webpack().Template.indent([`var installedCdnCssHref = {}`, `var importCdnCss = function(href) {`, _webpack().Template.indent([`var fullhref = href;`, `if (installedCdnCssHref[href]) {`, _webpack().Template.indent([`return null`]), `}`, `return new Promise(function(resolve, reject) {`, _webpack().Template.indent(['var existingLinkTags = document.getElementsByTagName("link");', 'for(var i = 0; i < existingLinkTags.length; i++) {', _webpack().Template.indent(['var tag = existingLinkTags[i];', 'var dataHref = tag.getAttribute("data-href") || tag.getAttribute("href");', 'if(tag.rel === "stylesheet" && (dataHref === href || dataHref === fullhref)) return resolve();']), '}', 'var existingStyleTags = document.getElementsByTagName("style");', 'for(var i = 0; i < existingStyleTags.length; i++) {', _webpack().Template.indent(['var tag = existingStyleTags[i];', 'var dataHref = tag.getAttribute("data-href");', 'if(dataHref === href || dataHref === fullhref) return resolve();']), '}', 'var linkTag = document.createElement("link");', 'linkTag.rel = "stylesheet";', 'linkTag.type = "text/css";', 'linkTag.onload = function() {', _webpack().Template.indent([`installedCdnCssHref[href] = 1`, `resolve()`]), `}`, 'linkTag.onerror = function(event) {', _webpack().Template.indent(['var request = event && event.target && event.target.src || fullhref;', 'var err = new Error("Loading CSS chunk " + href + " failed.\\n(" + request + ")");', 'err.code = "CDN_CSS_CHUNK_LOAD_FAILED";', 'err.request = request;', `delete installedCdnCssHref[href]`, 'linkTag.parentNode.removeChild(linkTag)', 'reject(err);']), '};', 'linkTag.href = fullhref;', 'var head = document.getElementsByTagName("head")[0];', 'head.appendChild(linkTag);']), `});`]), `}`]), `var cdnCss = ${JSON.stringify(cssObj, null, '\t')};`, `cdnCss[chunkId] && cdnCss[chunkId].forEach(function(ele) {`, _webpack().Template.indent([`var p = importCdnCss(ele)`, `if (p)`, _webpack().Template.indent([`promises.push(p)`])]), `})`])]);
      });
    });
  }

};